      SUBROUTINE DATINI
      INCLUDE 'prec.inc'
      COMPLEX*16 Z
      REAL*8 R(2)
      INCLUDE 'header.inc'
      INCLUDE 'minim.inc'
      INCLUDE 'parequ.inc'
      EQUIVALENCE (Z,R(1))
      DUTCODE(1)='0'
      DUTCODE(2)='1'
      DUTCODE(3)='3'
      DUTCODE(4)='4'
      DUTCODE(5)='5'
      DUTCODE(6)='6'
      DUTCODE(7)='7'
      DUTCODE(8)='8'
      DUTCODE(9)='A'
      DUTCODE(10)='B'
      DUTCODE(11)='C'
      DUTCODE(12)='D'
C Fill in start values for the NCODES different S11 parameters.
      IF(NCODES.NE.12)STOP "NCODES incorrect!! (datini.f)"      
      DO 10 I=1,NCODES
      DO 20 J=1,NEXP
      IF(DUT(J)(1:1).NE.DUTCODE(I))GOTO 20
      IF(DUT(J)(2:2).NE.' ')GOTO 20
      GAM_S11(I)=(Z_MEAS(J)-50)/(Z_MEAS(J)+50)
      GAM_S22(I)=GAM_S11(I)
      Z=GAM_S11(I)
      T=1-R(1)*R(1)-R(2)*R(2)-0.01
      R(1)=SQRT(0.5)*T
      R(2)=SQRT(0.5)*T
      GAM_S12(I)=Z
      GOTO 10
  20  CONTINUE
      WRITE(*,*)'NO START VALUE FOR DUT',DUTCODE(I)
      STOP
  10  CONTINUE
      NPAR=6*NCODES+4
      DO 100 I=1,NEXP
      DO 100 J=1,6
      IDUT(I,J)=0
      IF(DUT(I)(J:J).EQ.' ')GOTO 100
      DO 110 K=1,NCODES
      IF(DUTCODE(K).NE.DUT(I)(J:J))GOTO 110
      IDUT(I,J)=K
      GOTO 120
  110 CONTINUE
      STOP "ERROR DATINI"
  120 CONTINUE
  100 CONTINUE
      SHALLOWNESS=0.03
      OFFSET_NF=0
      R(1)=50
      R(2)=0
      Z_OPTNF=Z
      R(1)=0
      R(2)=0
      GAM_S11(1)=Z
      GAM_S22(1)=Z
      R(1)=1
      GAM_S12(1)=Z
      RETURN
      END
