      subroutine main
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'minim.inc'
      INCLUDE 'parequ.inc'
      CHARACTER LINE*80
      COMPLEX*16 ZTMP1,ZTMP2
      DIMENSION RTMP1(2),RTMP2(2)
      EQUIVALENCE (ZTMP1,RTMP1(1)),(ZTMP2,RTMP2(1))
      PI=ATAN2(0.0,-1.0)
      NEXP=0
      OPEN ( UNIT=5,FILE='nf.txt',STATUS='OLD',ERR=30)
   20 READ(5,520) LINE
      IF(LINE(1:3).EQ.'END') GOTO 30
      NEXP=NEXP+1
      IF(LINE(1:4).EQ.'NONE') THEN
C This is the reference load, DUT0, which reads 50, j0 ohms on the NVA
        DO 10 I=1,6
        DUT(NEXP)="0      "
   10   CONTINUE
      ELSE
      DO 21 I=1,6
      READ(LINE,530)	DUT(NEXP)
  530 FORMAT(A6)    
   21 CONTINUE
      ENDIF
 
      READ(LINE(7:70),*)N,TAMB,TE,RTMP1(1),RTMP1(2)
      TE26=TE-0.14*(TAMB-26.D0)
      NF26(NEXP)=10*LOG10(1+TE26/299)
      Z_MEAS(NEXP)=ZTMP1
c      write(*,678)dut(nexp),n,tamb,te,NF26(nexp),Z_MEAS(NEXP)
  678 FORMAT(A6,'  ',I5,5F9.4)
      J=0
      GOTO 20
   30 CONTINUE
      CLOSE (5)
C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      CALL DATINI
      NIT=1
      NITLAST=60
      ALFA=100
      IOUT=1
      NGEOM=0
      SUMOLD=1000
      DO 3310 I=1,NPAR
      STEP(I)=0.01
 3310 CONTINUE
 5000 DO 5005 I=1,NPAR
 5005 STEP(I)=-STEP(I)
      DO 3317 I=1,NPAR
      DO 3317 J=1,NPAR
 3317 ORTOG(I,J)=0
      DO 338 I=1,NPAR
      EMO(I)=1
 338  ORTOG(I,I)=1
 2000 ALFA=ALFA*.7
      IF(ALFA.LT..0001)ALFA=.0001
      CALL CALC(ERR(1),0,0)
      IF(SQSUM.LE.SUMOLD.OR.NIT.EQ.1)GO TO 1100
c      STOP 'STOP convergency problems.'
 1100 SUMOLD=SQSUM
      WRITE(*,611)SQSUM,ALFA,STEAVE
 611  FORMAT(' RMS error=',F12.5, '  alfa=',F13.8,'  step=',F9.6)
C   GET DERIVATIVES OF ERR VS THE PARAMETERS
      NIT=NIT+1
      DO 100 I=1,NPAR
      CALL PARSTE(I,1.D0)
      CALL CALC(DER(1,I),1,0)
      CALL PARSTE(I,-1.D0)
 100  CONTINUE
      DO 300 I=1,NPAR
      BARB(I)=0
      DO 300 J=1,NPAR
 300  UU(J,I)=0
      DO 400 I=1,NQU
      DO 400 J=1,NPAR
      BARB(J)=BARB(J)+ERR(I)*DER(I,J)
      DO 400 K=J,NPAR
 400  UU(J,K)=UU(J,K)+DER(I,J)*DER(I,K)
      NPARM=NPAR-1
      DO 410 I=1,NPARM
      I1=I+1
      DO 410 J=I1,NPAR
 410  UU(J,I)=UU(I,J)
      DO 412 I=1,NPAR
      DO 412 J=1,NPAR
 412  U(I,J)=UU(I,J)
      DO 420 I=1,NPAR
 420  UU(I,I)=UU(I,I)+ALFA/1000
C
      CALL LLSQ(NPAR)
      T=0
      DO 448 I=1,NPAR
 448  PAROLD(I)=PAR(I)
      DO 450 I=1,NPAR
 450  CALL PARSTE(I,-UPU(I))
      DO 414 I=1,NPAR
 414  T=T+(PAR(I)-PAROLD(I))**2
      if(NIT.EQ.NITLAST+1)THEN
        CALL CALC(ERR(1),0,1)
        STOP 
      ENDIF
      STEAVE=DSQRT(T)/NPAR
      NIT1=NIT1+1
      IF((NIT/2)*2.EQ.NIT)GO TO 5000
      CALL PDIAG
      DO 4006 I=1,NPAR
      TMP=1000*DSQRT(DABS(EMO(I)))
      IF(TMP.LT.1.)TMP=1.
 4006 EMO(I)=1./TMP
      DO 4020 I=1,NPAR
      DO 4020 J=1,NPAR
 4020 ORTOG(I,J)=U(I,J)
      GO TO 2000
  520 FORMAT(80A)       
      END
